// Include system headers (at warning level 3 because they're not /Wall-friendly)
#pragma warning(push, 3)
#include <windows.h>
#pragma warning(pop)

// Disable harmless /Wall warning C4514 "unreferenced inline function has been removed"
#pragma warning(disable: 4514)

// Default entry point function
int __stdcall WinMainCRTStartup()
{
	// Enable "terminate-on-corruption"
	(void)HeapSetInformation(NULL, HeapEnableTerminationOnCorruption, NULL, 0);

	// Find the "Show desktop" button/window (starting from the Desktop window)
	const HWND hwndTaskbar = FindWindowEx(NULL, NULL, TEXT("Shell_TrayWnd"), NULL);
	if (NULL != hwndTaskbar)
	{
		const HWND hwndNotify = FindWindowEx(hwndTaskbar, NULL, TEXT("TrayNotifyWnd"), NULL);
		if (NULL != hwndNotify)
		{
			const HWND hwndShowDesktopButton = FindWindowEx(hwndNotify, NULL, TEXT("TrayShowDesktopButtonWClass"), NULL);
			if (NULL != hwndShowDesktopButton)
			{
				// Toggle the visibility of the button
				const int nCmdShow = IsWindowVisible(hwndShowDesktopButton) ? SW_HIDE : SW_SHOW;
				(void)ShowWindow(hwndShowDesktopButton, nCmdShow);
			}
		}
	}

	// Return 0 because a message loop wasn't entered
	return 0;
}
